using System;
using System.IO;
using System.Diagnostics;
using System.Xml.Serialization;
using System.Windows.Forms;
using System.Collections.Generic;

namespace CsFileCopy
{
	/// <summary>
    /// CsFileCopy̐ݒǗNXłB
	/// </summary>
	public class ApplicationSettings
	{
        /// <summary>
        /// ͗őێB
        /// </summary>
        public const int INPUT_HISTORY_MAX = 10;

        /// <summary>
		/// AvP[V̐ݒ肪ύXꂽǂ\܂B
		/// </summary>
		private bool appSettingsChanged = false;

        /// <summary>
        /// ŌɎQƂĂofBNg
        /// </summary>
        private string lastBrowseExtractDirectory = "";

        /// <summary>
        /// ofBNgꗗ
        /// </summary>
        private List<string> extractDirectories = new List<string>();

        /// <summary>
        /// Ōɓ͂ꂽoΏۃt@C
        /// </summary>
        private string lastInputedExtractFiles = "";

        /// <summary>
        /// oΏۃt@Cꗗ
        /// </summary>
        private List<string> extractFiles = new List<string>();

        /// <summary>
        /// Ōɓ͂ꂽoOt@C
        /// </summary>
        private string lastInputedExceptFiles = "";

        /// <summary>
        /// oOt@Cꗗ
        /// </summary>
        private List<string> exceptFiles = new List<string>();

        /// <summary>
        /// ŌɎQƂĂofBNg
        /// </summary>
        private string lastBrowseDestinationDirectory = "";

        /// <summary>
        /// ofBNgꗗ
        /// </summary>
        private List<string> destinationDirectories = new List<string>();

		/// <summary>
		/// EBhE̕
		/// </summary>
		private int windowWidth = 0;

		/// <summary>
		/// EBhE̍
		/// </summary>
		private int windowHeight = 0;

		/// <summary>
		/// EBhEXW
		/// </summary>
		private int windowX = 0;

		/// <summary>
		/// EBhEYW
		/// </summary>
		private int windowY = 0;

		/// <summary>
		/// Iɍő剻Ԃłǂ
		/// </summary>
		private bool isMaximizedOnTerminate = false;

		/// <summary>
		/// TutH_邩ǂ
		/// </summary>
		private bool searchSubFolder = true;

        /// <summary>
        /// t@CXV́uFROMATOvIĂ邩ǂ
        /// </summary>
        private bool fromToRadioChecked = false;

        /// <summary>
        /// t@CXV́uȑOvIĂ邩ǂ
        /// </summary>
        private bool beforeRadioChecked = false;

        /// <summary>
        /// t@CXV́uȍ~vIĂ邩ǂ
        /// </summary>
        private bool afterRadioChecked = true;

        /// <summary>
        /// uXV𒊏oɊ܂߂ȂvIĂ邩ǂ
        /// </summary>
        private bool excludeUpdateTimeRadioChecked = false;

        /// <summary>
        /// oΏۃt@CAoOt@C͗̑啶uʂvIĂ邩ǂ
        /// </summary>
        private bool censeCaseRadioChecked = false;

        /// <summary>
        /// oΏۃt@CAoOt@C͗̑啶uʂȂvIĂ邩ǂ
        /// </summary>
        private bool ignoreCaseRadioChecked = true;

        /// <summary>
        /// J}؂胉WI{^`FbNĂ邩ǂ
        /// </summary>
        private bool commaRadioChecked = true;

        /// <summary>
        /// ^u؂胉WI{^`FbNĂ邩ǂ
        /// </summary>
        private bool tabRadioChecked = false;

        /// <summary>
        /// tpX`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        private bool fileFullPathChecked = true;

        /// <summary>
        /// t@CpX`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        private bool filePathChecked = false;

        /// <summary>
        /// t@C`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        private bool fileNameChecked = false;

        /// <summary>
        /// XV`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        private bool updateTimeChecked = true;

        /// <summary>
        /// uׂāvWI{^`FbNĂ邩ǂ
        /// </summary>
        private bool allRadioChecked = true;

        /// <summary>
        /// u`FbNẮvWI{^`FbNĂ邩ǂ
        /// </summary>
        private bool onlyCheckedRadioChecked = false;

		public ApplicationSettings()
		{
		}

        /// <summary>
        /// ŌɎQƂĂofBNgCfbNX
        /// </summary>
        public string LastBrowseExtractDirectory
        {
            get
            {
                return lastBrowseExtractDirectory;
            }
            set
            {
                lastBrowseExtractDirectory = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ofBNgꗗ
        /// </summary>
        public List<string> ExtractDirectories
        {
            get
            {
                return extractDirectories;
            }
        }

        /// <summary>
        /// Ōɓ͂ꂽoΏۃt@C
        /// </summary>
        public string LastInputedExtractFiles
        {
            get
            {
                return lastInputedExtractFiles;
            }
            set
            {
                lastInputedExtractFiles = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// oΏۃt@Cꗗ
        /// </summary>
        public List<string> ExtractFiles
        {
            get
            {
                return extractFiles;
            }
        }

        /// <summary>
        /// Ōɓ͂ꂽoOt@C
        /// </summary>
        public string LastInputedExceptFiles
        {
            get
            {
                return lastInputedExceptFiles;
            }
            set
            {
                lastInputedExceptFiles = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// oOt@Cꗗ
        /// </summary>
        public List<string> ExceptFiles
        {
            get
            {
                return exceptFiles;
            }
        }

        /// <summary>
        /// ŌɎQƂĂofBNg
        /// </summary>
        public string LastBrowseDestinationDirectory
        {
            get
            {
                return lastBrowseDestinationDirectory;
            }
            set
            {
                lastBrowseDestinationDirectory = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ofBNgꗗ
        /// </summary>
        public List<string> DestinationDirectories
        {
            get
            {
                return destinationDirectories;
            }
        }

		/// <summary>
		/// EBhE̕
		/// </summary>
		public int WindowWidth
		{
			get
			{
				return windowWidth;
			}
			set
			{
				windowWidth = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhE̍
		/// </summary>
		public int WindowHeight
		{
			get
			{
				return windowHeight;
			}
			set
			{
				windowHeight = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhEXW
		/// </summary>
		public int WindowX
		{
			get
			{
				return windowX;
			}
			set
			{
				windowX = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhEYW
		/// </summary>
		public int WindowY
		{
			get
			{
				return windowY;
			}
			set
			{
				windowY = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// Iɍő剻Ԃłǂ
		/// </summary>
		public bool IsMaximizedOnTerminate
		{
			get
			{
				return isMaximizedOnTerminate;
			}
			set
			{
				isMaximizedOnTerminate = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// TutH_邩ǂ
		/// </summary>
		public bool SearchSubFolder
		{
			get
			{
				return searchSubFolder;
			}
			set
			{
				searchSubFolder = value;
				appSettingsChanged = true;
			}
		}

        /// <summary>
        /// t@CXV́uFROMATOvIĂ邩ǂ
        /// </summary>
        public bool FromToRadioChecked
        {
            get
            {
                return fromToRadioChecked;
            }
            set
            {
                fromToRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// t@CXV́uȑOvIĂ邩ǂ
        /// </summary>
        public bool BeforeRadioChecked
        {
            get
            {
                return beforeRadioChecked;
            }
            set
            {
                beforeRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// t@CXV́uȍ~vIĂ邩ǂ
        /// </summary>
        public bool AfterRadioChecked
        {
            get
            {
                return afterRadioChecked;
            }
            set
            {
                afterRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// uXV𒊏oɊ܂߂ȂvIĂ邩ǂ
        /// </summary>
        public bool ExcludeUpdateTimeRadioChecked
        {
            get
            {
                return excludeUpdateTimeRadioChecked;
            }
            set
            {
                excludeUpdateTimeRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// oΏۃt@CAoOt@C̑啶uʂvIĂ邩ǂ
        /// </summary>
        public bool CenseCaseRadioChecked
        {
            get
            {
                return censeCaseRadioChecked;
            }
            set
            {
                censeCaseRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// oOt@CAoOt@C̑啶uʂȂvIĂ邩ǂ
        /// </summary>
        public bool IgnoreCaseRadioChecked
        {
            get
            {
                return ignoreCaseRadioChecked;
            }
            set
            {
                ignoreCaseRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// J}؂胉WI{^`FbNĂ邩ǂ
        /// </summary>
        public bool CommaRadioChecked
        {
            get
            {
                return commaRadioChecked;
            }
            set
            {
                commaRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ^u؂胉WI{^`FbNĂ邩ǂ
        /// </summary>
        public bool TabRadioChecked
        {
            get
            {
                return tabRadioChecked;
            }
            set
            {
                tabRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// tpX`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        public bool FileFullPathChecked
        {
            get
            {
                return fileFullPathChecked;
            }
            set
            {
                fileFullPathChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// t@CpX`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        public bool FilePathChecked
        {
            get
            {
                return filePathChecked;
            }
            set
            {
                filePathChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// t@C`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        public bool FileNameChecked
        {
            get
            {
                return fileNameChecked;
            }
            set
            {
                fileNameChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// XV`FbN{bNX`FbNĂ邩ǂ
        /// </summary>
        public bool UpdateTimeChecked
        {
            get
            {
                return updateTimeChecked;
            }
            set
            {
                updateTimeChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// uׂāvWI{^`FbNĂ邩ǂ
        /// </summary>
        public bool AllRadioChecked
        {
            get
            {
                return allRadioChecked;
            }
            set
            {
                allRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// u`FbNẮvWI{^`FbNĂ邩ǂ
        /// </summary>
        public bool OnlyCheckedRadioChecked
        {
            get
            {
                return onlyCheckedRadioChecked;
            }
            set
            {
                onlyCheckedRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ofBNgꗗNA܂B
        /// </summary>
        public void ClearExtractDirectories()
        {
            extractDirectories.Clear();

            appSettingsChanged = true;
        }

        /// <summary>
        /// ofBNgꗗɒǉ܂B
        /// </summary>
        /// <param name="dir">fBNg</param>
        public void AddExtractDirectory(string dir)
        {
            // ɓfBNg邩ǂ𒲂ׂ
            if (extractDirectories.Contains(dir))
            {
                // ݂̃CfbNX擾
                int index = extractDirectories.IndexOf(dir);

                // ݂̈ʒuɂfBNg폜
                extractDirectories.RemoveAt(index);
            }

            // ̐擪ɒǉ
            extractDirectories.Insert(0, dir);

            // ͗ێ𒴂ꍇ
            if (extractDirectories.Count > INPUT_HISTORY_MAX)
            {
                // Xg̍Ō̗vf폜
                extractDirectories.RemoveAt(
                    extractDirectories.Count - 1);
            }

            appSettingsChanged = true;
        }

        /// <summary>
        /// oΏۃt@CꗗNA܂B
        /// </summary>
        public void ClearExtractFiles()
        {
            extractFiles.Clear();

            appSettingsChanged = true;
        }

        /// <summary>
        /// oΏۃt@Cꗗɒǉ܂B
        /// </summary>
        /// <param name="file">t@C</param>
        public void AddExtractFile(string file)
        {
            // ɓt@C邩ǂ𒲂ׂ
            if (extractFiles.Contains(file))
            {
                // ݂̃CfbNX擾
                int index = extractFiles.IndexOf(file);

                // ݂̈ʒuɂt@C폜
                extractFiles.RemoveAt(index);
            }

            // ̐擪ɒǉ
            extractFiles.Insert(0, file);

            // ͗ێ𒴂ꍇ
            if (extractFiles.Count > INPUT_HISTORY_MAX)
            {
                // Xg̍Ō̗vf폜
                extractFiles.RemoveAt(
                    extractFiles.Count - 1);
            }

            appSettingsChanged = true;
        }

        /// <summary>
        /// oOt@CꗗNA܂B
        /// </summary>
        public void ClearExceptFiles()
        {
            exceptFiles.Clear();

            appSettingsChanged = true;
        }

        /// <summary>
        /// oOt@Cꗗɒǉ܂B
        /// </summary>
        /// <param name="file">Ot@C</param>
        public void AddExceptFile(string file)
        {
            // ɓt@C邩ǂ𒲂ׂ
            if (exceptFiles.Contains(file))
            {
                // ݂̃CfbNX擾
                int index = exceptFiles.IndexOf(file);

                // ݂̈ʒuɂt@C폜
                exceptFiles.RemoveAt(index);
            }

            // ̐擪ɒǉ
            exceptFiles.Insert(0, file);

            // ͗ێ𒴂ꍇ
            if (exceptFiles.Count > INPUT_HISTORY_MAX)
            {
                // Xg̍Ō̗vf폜
                exceptFiles.RemoveAt(
                    exceptFiles.Count - 1);
            }

            appSettingsChanged = true;
        }

        /// <summary>
        /// ofBNgꗗNA܂B
        /// </summary>
        public void ClearDestinationDirectories()
        {
            destinationDirectories.Clear();

            appSettingsChanged = true;
        }

        /// <summary>
        /// ofBNgꗗɒǉ܂B
        /// </summary>
        /// <param name="dir">fBNg</param>
        public void AddDestinationDirectory(string dir)
        {
            // ɓfBNg邩ǂ𒲂ׂ
            if (destinationDirectories.Contains(dir))
            {
                // ݂̃CfbNX擾
                int index = destinationDirectories.IndexOf(dir);

                // ݂̈ʒuɂfBNg폜
                destinationDirectories.RemoveAt(index);
            }

            // ̐擪ɒǉ
            destinationDirectories.Insert(0, dir);

            // ͗ێ𒴂ꍇ
            if (destinationDirectories.Count > INPUT_HISTORY_MAX)
            {
                // Xg̍Ō̗vf폜
                destinationDirectories.RemoveAt(
                    destinationDirectories.Count - 1);
            }

            appSettingsChanged = true;
        }

        /// <summary>
        /// ύXĂݒ肪ꍇANX\t@C
        /// VA܂B
        /// </summary>
        /// <returns>ύXĂݒ肪ꍇtrue,Ȃꍇfalse</returns>
        public bool SaveAppSettings()
        {
            if (this.appSettingsChanged)
            {
                StreamWriter myWriter = null;
                XmlSerializer mySerializer = null;

                try
                {
                    // ApplicationSettings ^
                    // XmlSerializer 쐬܂B
                    mySerializer = new XmlSerializer(typeof(ApplicationSettings));
                    myWriter =
                        new StreamWriter(
                        Application.StartupPath + @"\CsFileCopyConfig.xml", false);

                    // ApplicationSettings NX̂̃CX^X
                    // \t@CɃVA܂B
                    mySerializer.Serialize(myWriter, this);
                }
                catch (Exception ex)
                {
                    Debug.WriteLine(ex.Message);
                    Debug.WriteLine(ex.StackTrace);

                    MessageUtil.ShowAlert("CsFileCopy̐ݒ݂̏Ɏs܂B");
                }
                finally
                {
                    // FileStream JĂꍇ͕܂B
                    if (myWriter != null)
                    {
                        myWriter.Close();
                    }
                }
            }

            return appSettingsChanged;
        }

        /// <summary>
        /// \t@CNXVA܂B
        /// </summary>
        /// <returns>\t@Cꍇtrue,łȂꍇfalse</returns>
        public bool LoadAppSettings()
        {
            XmlSerializer mySerializer = null;
            FileStream myFileStream = null;
            bool fileExists = false;

            try
            {
                // ApplicationSettings ^ XmlSerializer 쐬܂B
                mySerializer = new XmlSerializer(typeof(ApplicationSettings));
                FileInfo fi = new FileInfo(
                    Application.StartupPath + @"\CsFileCopyConfig.xml");

                // \t@C݂ꍇ́AJ܂B
                if (fi.Exists)
                {
                    myFileStream = fi.OpenRead();
                    // \t@CVA邱ƂɂA
                    // ApplicationSettings ̐VKCX^X쐬܂B
                    ApplicationSettings myAppSettings =
                        (ApplicationSettings)mySerializer.Deserialize(
                        myFileStream);
                    // ApplicationSettings NX̂̃CX^X
                    // vpeBl蓖Ă܂B
                    this.lastBrowseExtractDirectory = myAppSettings.lastBrowseExtractDirectory;
                    this.extractDirectories = myAppSettings.extractDirectories;
                    this.lastInputedExtractFiles = myAppSettings.lastInputedExtractFiles;
                    this.extractFiles = myAppSettings.extractFiles;
                    this.lastInputedExceptFiles = myAppSettings.lastInputedExceptFiles;
                    this.exceptFiles = myAppSettings.exceptFiles;
                    this.lastBrowseDestinationDirectory = myAppSettings.lastBrowseDestinationDirectory;
                    this.destinationDirectories = myAppSettings.destinationDirectories;
                    this.windowHeight = myAppSettings.windowHeight;
                    this.windowWidth = myAppSettings.windowWidth;
                    this.windowX = myAppSettings.windowX;
                    this.windowY = myAppSettings.windowY;
                    this.isMaximizedOnTerminate = myAppSettings.isMaximizedOnTerminate;
                    this.searchSubFolder = myAppSettings.searchSubFolder;
                    this.fromToRadioChecked = myAppSettings.fromToRadioChecked;
                    this.beforeRadioChecked = myAppSettings.beforeRadioChecked;
                    this.afterRadioChecked = myAppSettings.afterRadioChecked;
                    this.excludeUpdateTimeRadioChecked = myAppSettings.excludeUpdateTimeRadioChecked;
                    this.censeCaseRadioChecked = myAppSettings.censeCaseRadioChecked;
                    this.ignoreCaseRadioChecked = myAppSettings.ignoreCaseRadioChecked;
                    this.commaRadioChecked = myAppSettings.commaRadioChecked;
                    this.tabRadioChecked = myAppSettings.tabRadioChecked;
                    this.fileFullPathChecked = myAppSettings.fileFullPathChecked;
                    this.filePathChecked = myAppSettings.filePathChecked;
                    this.fileNameChecked = myAppSettings.fileNameChecked;
                    this.updateTimeChecked = myAppSettings.updateTimeChecked;
                    this.allRadioChecked = myAppSettings.allRadioChecked;
                    this.onlyCheckedRadioChecked = myAppSettings.onlyCheckedRadioChecked;

                    fileExists = true;
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine(ex.Message);
                Debug.WriteLine(ex.StackTrace);

                MessageUtil.ShowAlert("CsFileCopy̐ݒ̓ǂݍ݂Ɏs܂B");
            }
            finally
            {
                // FileStream JĂꍇ͕܂B
                if (myFileStream != null)
                {
                    myFileStream.Close();
                }
            }

            return fileExists;
        }
    }
}
